/*------------------------------------------------------------------
 * Memcache Client. Autor Igor Vaskov 
 * Usage: addmemc.CMD <IP_Memcache> <key> <stime>
 * Example:
 * addmemc.CMD testkey 3600 file_name
--------------------------------------------------------------------*/
/*pull*/
TimeOut=60
server = "127.0.0.1"
port = 12112
debug=1
dt=DATE('S')
tm=TIME('N')
log_file="memc_out.log"
sdata = "hello world!"
endl='0D'x'0A'x

parse arg memckey stime fname
if (stime = '') then
do
  stime = '3600'
end

/*------------------------------------------------------------------
 * initialize socket package
 *------------------------------------------------------------------*/
if RxFuncQuery("SockLoadFuncs") then
do
      rc = RxFuncAdd("SockLoadFuncs","RxSock","SockLoadFuncs")
      rc = SockLoadFuncs()
end
/*------------------------------------------------------------------
 * get server name
 *------------------------------------------------------------------*/
rc = SockGetHostByName(server,"host.!")
if (rc = 0) then
do
      say "Error" h_errno "calling SockGetHostByName("server")"
      call log_store 'Error 'h_errno
      exit
end

   server = host.!addr;

/*---------------------------------------------------------------
 * open socket
 *---------------------------------------------------------------*/
socket  = SockSocket("AF_INET","SOCK_STREAM",0)
if (socket = -1) then
do
     say "Error on SockSocket:" errno
     call log_store errno
     exit
end

/*------------------------------------------------------------------
 * catch breaks
 *------------------------------------------------------------------*/
signal on halt

/*---------------------------------------------------------------
 * connect socket
 *---------------------------------------------------------------*/
server.!family = "AF_INET"
server.!port   = port
server.!addr   = server
if debug=1 then say 'Connect ------>>'
rc = SockConnect(socket,"server.!")
if (rc = -1) then
do
   call log_store errno h_errno
   say "Error on SockConnect:" errno h_errno
   exit
end
bsize = stream(fname,'c','query size')
if debug=1 then say 'add ------->>add 'memckey' 0 'stime' 'bsize''
rc = SockSend(socket,'add 'memckey' 0 'stime' 'bsize''endl)
if (rc = -1) then
do
   call log_store errno
   say "Error on SockSend:" errno
   exit
end
if debug=1 then say 'add ------->>'
rc = stream(fname,'c','open read')
do while chars(fname) <> 0
   xc = charin(fname,,1024)
/*   say xc */
   rc = SockSend(socket,xc)
   if (rc = -1) then
   do
      call log_store errno
      say "Error on SockSend:" errno
      exit
   end
end
rc = stream(fname,'c','close')

rc = SockSend(socket,endl)
if (rc = -1) then
do
   call log_store errno
   say "Error on SockSend:" errno
   exit
end

rc = memc_get("add_ret")
if (rc = -1) then
do
   call log_store errno
   say "Error on SockRecv:" errno
   exit
end
say add_ret
rc = memc_close()

exit
/*------------------------------------------------------------------
 * close socket (and catch signals)
 *------------------------------------------------------------------*/

halt:

rc = SockSoClose(socket)
if (rc = -1) then
   do
   say "Error on SockSoClose:" errno
   exit
   end

exit

memc_get:
arg rcbuf
rc=0
elapsed=0
tm=time('r')
DO WHILE rc<3 | elapsed > TimeOut
if debug=1 then say recieved loop
rc = SockRecv(socket,rcbuf,512)
if (rc = -1) then
   do
   say "Error on SockRecv:" errno
   rc = SockSoClose(socket)
   exit
   end
elapsed=time('e')
END
if (rc = 0) then
   do
   say "TimeOut on SockRecv"
   rc = SockSoClose(socket)
   exit
   end

return rc
memc_close:
rc = SockSend(socket,'quit'endl)
rc = SockSoClose(socket)
return 0

log_store:
arg note
call lineout log_file, log_buf note
call lineout log_file
return 0